/*
CrowlMINIEditor - Kris Merckx 2018
MIT-license
do not remove this copyright notice
*/

function CMEPasteCallback(editable, html){
    if (typeof html !== 'undefined'){
        var ht = html.html;
        ht = CleanWordHTML(ht);
        ht = cleanPaste(ht);
        editable.innerHTML = ht;
    }else{
        console.log("Not defined");
    }
}

var CleanWordHTML = function(str){
    str = str.replace(/<o:p>\s*<\/o:p>/g, "") ;
    str = str.replace(/<o:p>.*?<\/o:p>/g, "&nbsp;") ;
    str = str.replace( /\s*mso-[^:]+:[^;"]+;?/gi, "" ) ;
    str = str.replace( /\s*MARGIN: 0cm 0cm 0pt\s*;/gi, "" ) ;
    str = str.replace( /\s*MARGIN: 0cm 0cm 0pt\s*"/gi, "\"" ) ;
    str = str.replace( /\s*TEXT-INDENT: 0cm\s*;/gi, "" ) ;
    str = str.replace( /\s*TEXT-INDENT: 0cm\s*"/gi, "\"" ) ;
    str = str.replace( /\s*TEXT-ALIGN: [^\s;]+;?"/gi, "\"" ) ;
    str = str.replace( /\s*PAGE-BREAK-BEFORE: [^\s;]+;?"/gi, "\"" ) ;
    str = str.replace( /\s*FONT-VARIANT: [^\s;]+;?"/gi, "\"" ) ;
    str = str.replace( /\s*tab-stops:[^;"]*;?/gi, "" ) ;
    str = str.replace( /\s*tab-stops:[^"]*/gi, "" ) ;
    str = str.replace( /\s*face="[^"]*"/gi, "" ) ;
    str = str.replace( /\s*face=[^ >]*/gi, "" ) ;
    str = str.replace( /\s*FONT-FAMILY:[^;"]*;?/gi, "" ) ;
    str = str.replace(/<(\w[^>]*) class=([^ |>]*)([^>]*)/gi, "<$1$3") ;
    str = str.replace( /<(\w[^>]*) style="([^\"]*)"([^>]*)/gi, "<$1$3" ) ;
    str = str.replace( /\s*style="\s*"/gi, '' ) ; 
    str = str.replace( /<SPAN\s*[^>]*>\s*&nbsp;\s*<\/SPAN>/gi, '&nbsp;' ) ; 
    str = str.replace( /<SPAN\s*[^>]*><\/SPAN>/gi, '' ) ; 
    str = str.replace(/<(\w[^>]*) lang=([^ |>]*)([^>]*)/gi, "<$1$3") ; 
    str = str.replace( /<SPAN\s*>(.*?)<\/SPAN>/gi, '$1' ) ; 
    str = str.replace( /<FONT\s*>(.*?)<\/FONT>/gi, '$1' ) ;
    str = str.replace(/<\\?\?xml[^>]*>/gi, "") ; 
    str = str.replace(/<\/?\w+:[^>]*>/gi, "") ; 
   /* str = str.replace( /<H\d>\s*<\/H\d>/gi, '' ) ;
    str = str.replace( /<H1([^>]*)>/gi, '' ) ;
    str = str.replace( /<H2([^>]*)>/gi, '' ) ;
    str = str.replace( /<H3([^>]*)>/gi, '' ) ;
    str = str.replace( /<H4([^>]*)>/gi, '' ) ;
    str = str.replace( /<H5([^>]*)>/gi, '' ) ;
    str = str.replace( /<H6([^>]*)>/gi, '' ) ;
    str = str.replace( /<\/H\d>/gi, '<br>' ) ; */
    
    //remove this to take out breaks where Heading tags were 
    str = str.replace( /<(U|I|STRIKE)>&nbsp;<\/\1>/g, '&nbsp;' ) ;
    str = str.replace( /<(B|b)>&nbsp;<\/\b|B>/g, '' ) ;
    str = str.replace( /<([^\s>]+)[^>]*>\s*<\/\1>/g, '' ) ;
    str = str.replace( /<([^\s>]+)[^>]*>\s*<\/\1>/g, '' ) ;
    str = str.replace( /<([^\s>]+)[^>]*>\s*<\/\1>/g, '' ) ;
    //some RegEx code for the picky browsers
    var re = new RegExp("(<P)([^>]*>.*?)(<\/P>)","gi") ;
    str = str.replace( re, "<div$2</div>" ) ;
    var re2 = new RegExp("(<font|<FONT)([^*>]*>.*?)(<\/FONT>|<\/font>)","gi") ; 
    str = str.replace( re2, "<div$2</div>") ;
    str = str.replace( /size|SIZE = ([\d]{1})/g, '' ) ;
    return str ;
}



var cleanPaste = function(html) {
    // Run the standard YUI cleanHTML method

    // Remove additional MS Word content
    html = html.replace(/<(\/)*(\\?xml:|meta|link|span|font|del|ins|st1:|[ovwxp]:)((.|\s)*?)>/gi, ''); // Unwanted tags
    html = html.replace(/(class|style|type|start)=("(.*?)"|(\w*))/gi, ''); // Unwanted sttributes
    html = html.replace(/<style(.*?)style>/gi, '');   // Style tags
    html = html.replace(/<script(.*?)script>/gi, ''); // Script tags
    html = html.replace(/<!--(.*?)-->/gi, '');        // HTML comments
    
    return html;
}

var CMECaret = 0;
/*Start cursor*/
function getCaret(element) {
    var caretOffset = 0;
    var doc = element.ownerDocument || element.document;
    var win = doc.defaultView || doc.parentWindow;
    var sel;
    if (typeof win.getSelection != "undefined") {
        sel = win.getSelection();
        if (sel.rangeCount > 0) {
            var range = win.getSelection().getRangeAt(0);
            var preCaretRange = range.cloneRange();
            preCaretRange.selectNodeContents(element);
            preCaretRange.setEnd(range.endContainer, range.endOffset);
            caretOffset = preCaretRange.toString().length;
        }
    } else if ( (sel = doc.selection) && sel.type != "Control") {
        var textRange = sel.createRange();
        var preCaretTextRange = doc.body.createTextRange();
        preCaretTextRange.moveToElementText(element);
        preCaretTextRange.setEndPoint("EndToEnd", textRange);
        caretOffset = preCaretTextRange.text.length;
    }
    return caretOffset;
}

    /**
         * Adds a paste event handler to a contentEditable node
         * and calls the passed callback with an object that has
         * html and/or text properties along with any other mime
         * types that were pasted.
         *
         * @author Sam Clarke <samclarke.com>
         * @license MIT
         */
    function detectPaste(editable, callback) {
      var IMAGE_MIME_REGEX = /^image\/(p?jpe?g|gif|png|bmp)$/i;
      var isIE = !!document.documentMode;
      var isEdge = '-ms-ime-align' in document.documentElement.style;
      var prePasteContent;

      function loadImage(file) {
        var reader = new FileReader();
        reader.onload = function (e) {
          callback({ html: '<img src="' + e.target.result + '" />' });
        };
        reader.readAsDataURL(file);
      };

      editable.addEventListener('paste', function (e) {
        var clipboard = e.clipboardData;

        // Modern browsers with clipboard API - everything other than
        // _very_ old android web views and UC browser which doesn't
        // support the paste event at all.
        // Need to also ignore IE as only has text and URL support
        if (clipboard && !(isIE || isEdge)) {
          var data = {};
          var types = clipboard.types;
          var items = clipboard.items;

          e.preventDefault();

          for (var i = 0; i < types.length; i++) {
            // Normalise image pasting to paste as a data-uri
            if (window.FileReader && items &&
              IMAGE_MIME_REGEX.test(items[i].type)) {
              return loadImage(clipboard.items[i].getAsFile());
            }

            data[types[i]] = clipboard.getData(types[i]);
          }

          data.text = data['text/plain'];
          data.html = data['text/html'];

          callback(editable, data);
        // If fragment exists then we're already waiting for a
        // previous paste so let that handler for that handle this one
        } else if (!prePasteContent) {
          // Save the scroll position so can restore it with contents
          var scrollTop = editable.scrollTop;

          prePasteContent = document.createDocumentFragment();
          while (editable.firstChild) {
            prePasteContent.appendChild(editable.firstChild);
          }

          setTimeout(function () {
            var html = editable.innerHTML;

            editable.innerHTML = '';
            editable.appendChild(prePasteContent);
            editable.scrollTop = scrollTop;
            prePasteContent = false;

            callback(editable, html);
          }, 0);
        }
      });
    }


/*https://github.com/yabwe/medium-editor/issues/730*/
 function setCaret(el, caretPosition) {
            el.focus();

            var range = document.createRange(),
                    sel;

            range.selectNodeContents(el);

            function findTargetNode(node) {
                // console.log('node.nodeType = %d, caretPosition = %d.', node.nodeType, caretPosition, node);

                if (node.nodeType > 3) {
                    // Only iterate over elements and text nodes.
                    return;
                }

                // If we hit a text node, we need to add the
                // amount of characters to the overall count.
                if (node.nodeType === 3) {
                    // console.log('node.length', node.length);

                    if (node.length > caretPosition) {
                        return {
                            node: node,
                            offset: caretPosition
                        };
                    } else if (node.length == caretPosition) {
                        return {
                            node: node,
                            offset: 0
                        };
                    } else {
                        caretPosition -= node.length;
                    }
                }
                // Otherwise, the `nodeType = 1` meaning it is a node.

                for (var i = 0, nodeObj; i < node.childNodes.length; ++i) {
                    nodeObj = findTargetNode(node.childNodes[i]);

                    if (nodeObj) {
                        return nodeObj;
                    }
                }
            }

            switch (caretPosition) {
                case -1:
                    // `-1` caret position indicates that we need
                    // to position the caret at the end of the section.

                    // Passing `false` to `collapse` sets the start
                    // and end points at the same end position.
                    range.collapse(false);
                    break;
                case 0:
                    // `0` caret position indicates that we need
                    // to position the caret at the start of the section.

                    // Passing `true` to `collapse` sets the start
                    // and end points at the same start position.
                    range.collapse(true);

                    break;
                default:
                    // Otherwise, position the caret at the specific
                    // index.
                    var nodeObj = findTargetNode(el);

                    // console.log('nodeObj', nodeObj);

                    if (nodeObj) {
                        range.setStart(nodeObj.node, nodeObj.offset);
                        range.setEnd(nodeObj.node, nodeObj.offset);
                    }
            }

            sel = window.getSelection();

            sel.removeAllRanges();
            sel.addRange(range);
     return true;
}

/*https://stackoverflow.com/questions/6690752/insert-html-at-caret-in-a-contenteditable-div*/
function pasteCaret(html, selectPastedContent) {
    var sel, range;
    if (window.getSelection) {
        // IE9 and non-IE
        sel = window.getSelection();
        if (sel.getRangeAt && sel.rangeCount) {
            range = sel.getRangeAt(0);
            range.deleteContents();

            // Range.createContextualFragment() would be useful here but is
            // only relatively recently standardized and is not supported in
            // some browsers (IE9, for one)
            var el = document.createElement("div");
            el.innerHTML = html;
            var frag = document.createDocumentFragment(), node, lastNode;
            while ( (node = el.firstChild) ) {
                lastNode = frag.appendChild(node);
            }
            var firstNode = frag.firstChild;
            range.insertNode(frag);

            // Preserve the selection
            if (lastNode) {
                range = range.cloneRange();
                range.setStartAfter(lastNode);
                if (selectPastedContent) {
                    range.setStartBefore(firstNode);
                } else {
                    range.collapse(true);
                }
                sel.removeAllRanges();
                sel.addRange(range);
            }
        }
    } else if ( (sel = document.selection) && sel.type != "Control") {
        // IE < 9
        var originalRange = sel.createRange();
        originalRange.collapse(true);
        sel.createRange().pasteHTML(html);
        if (selectPastedContent) {
            range = sel.createRange();
            range.setEndPoint("StartToStart", originalRange);
            range.select();
        }
    }
}



/*Einde cursor*/
                function CEMCreateLink() {
                    var linkURL = prompt('Voer een link in:', 'http://');
                    var newLink = document.execCommand('createlink', false, linkURL);
                    //newLink.target = "_blank";
                }
            var CEMSelectedImg;
            var CEMImageFolder = "";
            var CEMImageDropMultiple = false;
            var CEMImgEditor = function(){
                
            }
            var IMGUPLOADTPL = '\
                <input type="file" id="fileElem" multiple accept="image/*" style="display:none">\
                <button id="UPLFileselect" class="CMEbtn CUPL"><i class="fa fa-camera" aria-hidden="true"></i></button>\
            ';
            
            var IMGEDITORTPL = "\
                            <button class='REMOVEIMG' style='float:right;'>Verwijder</button>\
                            <label>Uitlijning</label>\
                            <select class='floatstyle' style='width:100%;'>\
                                <option value='none' data-style='float:none;'>Geen omloop</option>\
                                <option value='left' data-style='float:left;margin-right:20px;'>Links, tekst rechts</option>\
                                <option value='right' data-style='float:right;margin-left:20px;'>Rechts, tekst links</option>\
                            </select>\
                            <label>Breedte afbeelding</label>\
                            <select class='imgwidth' style='width:100%;'>\
                                <option data-style='width:100%;'>100%</option>\
                                <option data-style='width:50%;'>50%</option>\
                                <option data-style='width:33%;'>33%</option>\
                                <option data-style='width:25%;'>25%</option>\
                            </select>\
                            <label>Roteer afbeelding</label>\
                            <select class='imgrotate' style='width:100%;'>\
                                <option data-style='transform:;'>Niet</option>\
                                <option data-style='transform:rotate(-90deg);'>Links</option>\
                                <option data-style='transform:rotate(90deg);'>Rechts</option>\
                            </select>\
                            <label>Filtereffecten</label>\
                            <select class='imgfilter' style='width:100%;'>\
                                <option data-style='filter:initial;'>Geen</option>\
                                <option data-style='filter:grayscale(100%);'>Grijstinten</option>\
                                <option data-style='filter:invert(100%);'>Negatief</option>\
                                <option data-style='filter:sepia(100%);'>Sepia</option>\
                                <option data-style='filter:blur(5px);'>Vervagen</option>\
                            </select>\
                            <button class='CLOSEIEMODAL'>SLUIT</button>\
            ";

            var duToImg = function(){
                $(".mysmallcrowleditor").find("img").each(function(){
                    $(this).css("cursor", "pointer");
                    $(this).on("click", function(){
                        CEMSelectedImg = $(this); 
                        var ie = $("<div></div>");
                        ie.addClass("IMGEDITOR").addClass("shadow");
                        var h = IMGEDITORTPL;
                        //alert(h);
                        ie.html(h);
                        $("#editorwrapper").append(ie);
                        $(".REMOVEIMG").on("click", function(e){
                            CEMSelectedImg.remove();
                            $(this).closest(".IMGEDITOR").remove();
                        });
                        $(".imgwidth, .floatstyle, .imgfilter, .imgrotate").on("change", function(){
                            var f = $(".imgwidth option:selected").attr("data-style");
                            var olds = $(".floatstyle option:selected").attr("data-style");
                            var filter = $(".imgfilter option:selected").attr("data-style");
                            var rotate = $(".imgrotate option:selected").attr("data-style");
                            f = olds + f + filter + rotate;
                            CEMSelectedImg.attr("style", f);
                        });
                        $(".CLOSEIEMODAL").on("click", function(){
                            $(this).closest(".IMGEDITOR").remove();
                        });
                    });
                    var pic= $(this);
					var imgsrc=pic.attr("src");
			        var ch= imgsrc.indexOf("data:");
                    var retextension="jpg";
                    if(ch>-1){
                        var extension= imgsrc.indexOf("image/jpeg");
                        if(extension>-1){
                            retextension="jpg";
                        }
                        extension= imgsrc.indexOf("image/jpg");
                        if(extension>-1){
                            retextension="jpg";
                        }
                        extension= imgsrc.indexOf("image/png");
                        if(extension>-1){
                            retextension="png";
                        }
                        extension= imgsrc.indexOf("image/gif");
                        if(extension>-1){
                            retextension="gif";
                        }
                        $.post("saveimg.php", {
                                imageFolder: CEMImageFolder + "/",
				                imageData : imgsrc,
                                extension: retextension
				            }, function(data) {
                                if(CEMImageFolder.length > 0){
                                    CEMImageFolder = CEMImageFolder + "/";
                                }
								pic.attr("src", CEMImageFolder + data);
				            }
                        );
                    }
                });
            }
            var CEMDrag = function(e) {
                //kill any default behavior
                e.stopPropagation();
                e.preventDefault();
                if(!CEMImageDropMultiple){
                    $(".mysmallcrowlimagedropper").find("img").remove();
                }
            };
            var CEMDrop = function(e) {
                //kill any default behavior
                e.stopPropagation();
                e.preventDefault();
                //console.log(e);
                //get x and y coordinates of the dropped item
                x = e.clientX;
                y = e.clientY;
                //drops are treated as multiple files. Only dealing with single files right now, so assume its the first object you're interested in
                var file = e.dataTransfer.files[0];
                //don't try to mess with non-image files
                if (file.type.match('image.*')) {
                    //then we have an image,

                    //we have a file handle, need to read it with file reader!
                    var reader = new FileReader();

                    // Closure to capture the file information.
                    reader.onload = (function(theFile) {
                        //get the data uri
                        var dataURI = theFile.target.result;
                        //make a new image element with the dataURI as the source
                        var img = document.createElement("img");
                        img.src = dataURI;

                        //Insert the image at the carat

                        // Try the standards-based way first. This works in FF
                        if (document.caretPositionFromPoint) {
                            var pos = document.caretPositionFromPoint(x, y);
                            range = document.createRange();
                            range.setStart(pos.offsetNode, pos.offset);
                            range.collapse();
                            range.insertNode(img);
                            duToImg();
                        }
                        // Next, the WebKit way. This works in Chrome.
                        else if (document.caretRangeFromPoint) {
                            range = document.caretRangeFromPoint(x, y);
                            range.insertNode(img);
                            duToImg();
                        }
                        else
                        {
                            //not supporting IE right now.
                            console.log('could not find carat');
                        }
                        

                    });
                    //this reads in the file, and the onload event triggers, which adds the image to the div at the carat
                    reader.readAsDataURL(file);
                }
            };


(function ( $ ) {
    $.fn.CrowlMiniEditor = function(options) {
        var settings = $.extend({
            // These are the defaults.
            className: "CrowlMiniEditor",
            imageFolder: "",
            boldBtn : '<i class="fa fa-bold" aria-hidden="true"></i>',
            olBtn: '<i class="fa fa-list-ol" aria-hidden="true"></i>',
            ulBtn: '<i class="fa fa-list-ul" aria-hidden="true"></i>',
            linkBtn: '<i class="fa fa-link" aria-hidden="true"></i>',
            removeformatBtn: '<i class="fa fa-eraser" aria-hidden="true"></i>',
            htmlBtn: '<i class="fa fa-code" aria-hidden="true"></i>',
            codeBtn: '<i class="fa fa-code" aria-hidden="true"></i>',
            italicBtn: '<i class="fa fa-italic" aria-hidden="true"></i>',
            underlineBtn: '<i class="fa fa-underline" aria-hidden="true"></i>',
            cutBtn: '<i class="fa fa-scissors" aria-hidden="true"></i>',
            pasteBtn: '<i class="fa fa-clipboard" aria-hidden="true"></i>',
            saveBtn: '<i class="fa fa-floppy-o" aria-hidden="true"></i>'
        }, options );
        
        CEMImageFolder = settings.imageFolder;
        
        $("<link>").prop("rel", "stylesheet").prop("href", "//netdna.bootstrapcdn.com/font-awesome/4.6.2/css/font-awesome.css").appendTo("head");
    
        $("<style>")
            .prop("type", "text/css")
            .html("\.CrowlMiniEditor img{\
                        max-width:100%;\
                    }\
                    body{\
                        position:relative;\
                    }\
                    .CMEModal, .IMGEDITOR{\
                        width:550px;\
                        height:370px;\
                        background-color:white;\
                        background-color:rgba(255,255,255,0.9);\
                        position:absolute;\
                        border:1px solid lightblue;\
                        z-index:21474836472;\
                        left:50%;\
                        top:50%;\
                        padding:20px;\
                        overflow:auto;\
                        transform: translate(-50%, -50%);\
                    }\
                    .CMEModal textarea{\
                        height:300px;\
                        width:100%;\
                    }\
                    ").appendTo("head");
        
        /*Knoppen maken*/
        
        var btnSave = $("<button/>");
        btnSave.addClass("saveme CMEbtn");
        btnSave.html(settings.saveBtn);
        
        var btnBold = $("<button/>");
        btnBold.addClass("setBold CMEbtn");
        btnBold.html(settings.boldBtn);
        
        var btnItalic = $("<button/>");
        btnItalic.addClass("setItalic CMEbtn");
        btnItalic.html(settings.italicBtn);
        
        var btnUnderline = $("<button/>");
        btnUnderline.addClass("setUnderline CMEbtn");
        btnUnderline.html(settings.underlineBtn);
        
        var btnH1 = $("<button/>");
        btnH1.addClass("setH1 CMEbtn");
        btnH1.text("H1");
        
        var btnH2 = $("<button/>");
        btnH2.addClass("setH2 CMEbtn");
        btnH2.text("H2");
        
        var btnH3 = $("<button/>");
        btnH3.addClass("setH3 CMEbtn");
        btnH3.text("H3");
        
        var btnLINK = $("<button/>");
        btnLINK.addClass("setLink CMEbtn");
        btnLINK.html(settings.linkBtn);
        
        var btnHTML = $("<button/>");
        btnHTML.addClass("setHTML CMEbtn");
        btnHTML.html(settings.htmlBtn);
        
        var btnCODEVIEW = $("<button/>");
        btnCODEVIEW.addClass("setCODE CMEbtn");
        btnCODEVIEW.html(settings.codeBtn);
        
        var btnOL = $("<button/>");
        btnOL.addClass("setOL CMEbtn");
        btnOL.html(settings.olBtn);
        
        var btnUL = $("<button/>");
        btnUL.addClass("setUL CMEbtn");
        btnUL.html(settings.ulBtn);
        
        var btnCUT = $("<button/>");
        btnCUT.addClass("cutme CMEbtn");
        btnCUT.html(settings.cutBtn);
        
        var btnPASTE = $("<button/>");
        btnPASTE.addClass("pasteit CMEbtn");
        btnPASTE.html(settings.pasteBtn);
        
        var btnRF = $("<button/>");
        btnRF.addClass("remFM CMEbtn");
        btnRF.html(settings.removeformatBtn);
        
        var UPL = $("<span/>");
        UPL.addClass("uploadspan");
        UPL.html(IMGUPLOADTPL);
        
        /*einde knoppen*/
        
        return this.each( function() {
            var ta = $(this);
            $(this).css("display", "none");
            var editor = $("<div/>");
            editor.attr("contenteditable", "true");
            var tcontent = ta.val();
            editor.html(tcontent);
            editor.find(".codeExample").each(function(){
                var h = $(this).html();
                h = h.replace(/<br>/g, 'BRX');
                h = h.replace(/</g, '&lt;');
                h = h.replace(/>/g, '&gt;');
                h = h.replace(/BRX/g, '<br>');
                h = h.replace(/&lt;PHP/g, '&lt;?PHP');
                $(this).html(h);
            });
            
            editor.addClass(settings.className);
            $(this).after(editor);
            editor.addClass("mysmallcrowleditor");
            
            editor.on("click, keydown, keyup", function(){
                var element = editor[0];
                CMECaret = getCaret(element);
            });
            
            /*knoppenbalk genereren*/
            var bar = $("<div/>");
            bar.addClass("CrowlBtnBar");
            editor.before(bar);
      
            editor.prev(".CrowlBtnBar").append(btnSave);
            editor.prev(".CrowlBtnBar").append(btnBold);
            editor.prev(".CrowlBtnBar").append(btnItalic);
            editor.prev(".CrowlBtnBar").append(btnUnderline);
            editor.prev(".CrowlBtnBar").append(btnH1);
            editor.prev(".CrowlBtnBar").append(btnH2);
            editor.prev(".CrowlBtnBar").append(btnH3);
            editor.prev(".CrowlBtnBar").append(btnLINK);
            editor.prev(".CrowlBtnBar").append(btnHTML);
            editor.prev(".CrowlBtnBar").append(btnCODEVIEW);
            editor.prev(".CrowlBtnBar").append(btnOL);
            editor.prev(".CrowlBtnBar").append(btnUL);
            editor.prev(".CrowlBtnBar").append(UPL);
            editor.prev(".CrowlBtnBar").append(btnCUT);
            editor.prev(".CrowlBtnBar").append(btnPASTE);
            editor.prev(".CrowlBtnBar").append(btnRF);
            
            var placeholder = $("<span/>");
            placeholder.css("display", "none");
            placeholder.attr("id", "CMEplaceholder");
            placeholder.html("<img src=''/>");
            editor.before(placeholder);
            
            
            $(".CUPL").on("click", function(e){
                e.preventDefault();
                
                var fileselect= $(this).prev("input");
                fileselect.click();
                fileselect.on("change", function(){
                    var reader = new FileReader();
                    reader.onload = function (e) {
                        $("#CMEplaceholder").find("img").attr("src", e.target.result);
                        var element = editor[0];
                        
                        var sc = setCaret(element, CMECaret);
                        var h = $("#CMEplaceholder").html();
                        if(sc){
                            document.execCommand("insertHTML", false, h);
                            duToImg();
                        }
                        
                        
                    };
                    reader.readAsDataURL(this.files[0]);
                });
            });
            
            
            $(".saveme").on("click", function(e){
                e.preventDefault();
                $("#save").click();
            });

            $(".remFM").on("click", function(e){
                e.preventDefault();
                var container = null;
                if (document.selection){
                    container = document.selection.createRange().parentElement();
                }else {
                    var select = window.getSelection();
                    if (select.rangeCount > 0){
                        container = select.getRangeAt(0).startContainer.parentNode;
                    }
                }
                var chclass = $(container).attr("class");
                if (typeof chclass !== "undefined" && chclass.indexOf("mysmallcrowleditor") > -1){
                    
                }else{
                    $(container).contents().unwrap();
                }

                document.execCommand("removeformat", false, "");
            });
            
            $(".setBold").on("click", function(e){
                e.preventDefault();
                document.execCommand("bold");
            });
            $(".setItalic").on("click", function(e){
                e.preventDefault();
                document.execCommand("italic");
            });
            $(".setUnderline").on("click", function(e){
                e.preventDefault();
                document.execCommand("underline");
            });
            $(".setOL").on("click", function(e){
                e.preventDefault();
                document.execCommand("insertOrderedList");
            });
            $(".setUL").on("click", function(e){
                e.preventDefault();
                document.execCommand("insertUnorderedList");
            });
            $(".setH1").on("click", function(e){
                e.preventDefault();
                document.execCommand('formatBlock', false, '<h1>');
            });
            $(".setH2").on("click", function(e){
                e.preventDefault();
                document.execCommand('formatBlock', false, '<h2>');
            });
            $(".setH3").on("click", function(e){
                e.preventDefault();
                document.execCommand('formatBlock', false, '<h3>');
            });
            $(".setLink").on("click", function(e){
                e.preventDefault();
                CEMCreateLink();
            });
            $(".cutme").on("click", function(e){
                e.preventDefault();
                document.execCommand("cut");
            });
            $(".pasteit").on("click", function(e){
                e.preventDefault();
                document.execCommand("paste");
                alert("Gebruik CTRL+V (Linux of Windows) of CMD+V (Mac OS)");
            });
            $(".setCODE").on("click", function(e){
                e.preventDefault();
                var element = editor[0];
                var h = '<div class="codeExample terminal">//plak</div>';

                    document.execCommand("insertHTML", false, h);
            });
            
            
            detectPaste(editor[0], CMEPasteCallback)
            
            $(".setHTML").on("click", function(e){
                e.preventDefault();
                var window = $("<div/>");
                window.addClass("CMEModal");
                window.addClass("shadow");
                window.html("<textarea></textarea><button class='CMEInsertHTML'>Voeg toe</button>");
                $("#editorwrapper").append(window);
                $(".CMEInsertHTML").on("click", function(e){
                    e.preventDefault();
                    var h = $(this).prev("textarea").val();
                    var element = editor[0];
                    var sc = setCaret(element, CMECaret);
                    if(sc){
                        document.execCommand("insertHTML", false, h);
                    }
                    //document.execCommand("insertHTML", true, h);
                    $(".CMEModal").remove();
                });
            });
            /*einde knoppenbalk*/
            
            editor[0].addEventListener('dragover', CEMDrag, false);
            editor[0].addEventListener('drop', CEMDrop, false);
            
            ta.closest("form").on("submit", function(e){
                e.preventDefault();
                
                editor.find(".codeExample").each(function(){
                    var h = $(this).html();
                    h = h.replace(/</g, '&lt;');
                    h = h.replace(/>/g, '&gt;');
                    $(this).html(h);
                    alert(h);
                });
                
                var html = editor.html();
                
                ta.val(html);
                
                $(this).unbind("submit").submit();
            });
        });
    }; 
}( jQuery ));


(function ( $ ) {
    $.fn.CrowlImageDrop = function(options) {
        var settings = $.extend({
            // These are the defaults.
            className: "CrowlImageDrop",
            imageFolder: "",
            multiple: true
        }, options );
        
        CEMImageFolder = settings.imageFolder;
        CEMImageDropMultiple = settings.multiple;
        
        $("<style>")
            .prop("type", "text/css")
            .html("\.CrowlImageDrop img{\
                        max-width:20%;\
                        margin:20px;\
                    }\
                  .CrowlImageDrop{\
                        padding:0px;\
                        border:1px solid lightblue;\
                        width:95%;\
                        height:100px;\
                        overflow:auto;\
                    }").appendTo("head");
        
        return this.each( function() {
            var ta = $(this);
            //$(this).css("display", "none");
            var editor = $("<div/>");
            
            editor.attr("contenteditable", "true");
            
            editor.addClass(settings.className);
            $(this).after(editor);
            editor.addClass("mysmallcrowleditor").addClass("mysmallcrowlimagedropper");
            
            editor[0].addEventListener('dragover', CEMDrag, false);
            editor[0].addEventListener('drop', CEMDrop, false);
            
            editor.keypress(function(event){
                event.preventDefault();
            });
            
            editor.bind('copy paste cut',function(e){
                e.preventDefault();
                alert("Plakken niet toegestaan");
            });
            
            ta.closest("form").on("submit", function(e){
                e.preventDefault();
                editor.find("*").not("img").remove();
                var html = editor.find("img:first").attr("src");
                
                editor.find(".codeExample").each(function(){
                    var h = $(this).html();
                    h = h.replace(/</g, '&lt;');
                    h = h.replace(/>/g, '&gt;');
                    $(this).html(h);
                });
                
                ta.val(html);
                $(this).unbind("submit").submit();
            });
        });
    }; 
}( jQuery ));