<?PHP

/*
Code by Kris Merckx - 2018
Part & port of Crowl STDIO.PHP
MIT-license
Do not remove this copyright notice
*/

define("HOST",$servername);
define("USER",$username);
define("PWD",$password);
define("DATABASE",$dbname);

$GLOBALS['dateformat'] = "d/m/Y";

class Database {
	private $_connection;
	private static $_instance; //The single instance
	private $_host = HOST;
	private $_username = USER;
	private $_password = PWD;
	private $_database = DATABASE;

	public static function OPEN() {
		if(!self::$_instance) { // If no instance then make one
			self::$_instance = new self();
		}
		return self::$_instance;
	}

    private function __construct() {
        $con = new mysqli($this->_host, $this->_username, 
			$this->_password, $this->_database);
        //$con->set_charset("utf8");
        
		$this->_connection = $con;
        //$this->_connection->set_charset("utf8")
		// Error handling
		if(mysqli_connect_error()) {
			trigger_error("Oohoo. Crowl can't find the database: " . mysql_connect_error(), E_USER_ERROR);
		}
	}
    
	// Magic method clone is empty to prevent duplication of connection
	private function __clone() { }
	// Get mysqli connection
	public function CONNECT() {
		return $this->_connection;
	}
    
    public function CRUDQ(){
        return $this->_connection;
    }
    
    public function Q($sql){
        //geen drop, delete, update, insert 
        $sqlC = strtolower($sql);
        $D = strpos($sqlC,"delete");
        $I = strpos($sqlC, "insert");
        $DR = strpos($sqlC, "drop");
        $U = strpos($sqlC, "update");
        $A = strpos($sqlC, "alter");

        if($D > -1 || $I > -1 || $DR > -1 || $U > -1  || $A > -1){
            echo "mag niet uitgevoerd worden";
        }else{
            //$this->_connection->query('SET NAMES utf8');
            $result = $this->_connection->query($sql);
            return $result;
        } 
    }
    
    public function C($sql){
        $result = $this->_connection->query($sql);
        return $result->num_rows;
    }
    
    public function CN($table){
        $sql = "SHOW COLUMNS FROM $table";
        $result = $this->_connection->query($sql);
        
        $CNS=array();
        while($row = mysqli_fetch_array($result)){
            array_push($CNS,$row['Field']);
        }
        return $CNS;
    }
    
    public function __destruct() {
        $this->_connection->close();
    }

}

class SETDATEFORMAT{
    public function __construct($format) {
        $GLOBALS['dateformat'] = $format;
    }
    
}

class DDT{
    private $x;
    
    public function __construct($datestring, $format) {
        $time = strtotime($datestring);
        
        /*Maanden*/
        $men = array('january', 'february', 'march', 'april', 'may', 'june', 'july', 'august', 'september', 'october', 'november', 'december');
        $mnl = array('januari', 'februari', 'maart', 'april', 'mei', 'juni', 'juli', 'augustus', 'september','oktober', 'november', 'december');
        
        /*Maanden*/
        $maen = array('jan', 'feb', 'mar', 'apr', 'may', 'jun', 'jul', 'aug', 'sep', 'oct', 'nov', 'dec');
        $manl = array('jan', 'feb', 'maa', 'apr', 'mei', 'jun', 'jul', 'aug', 'sept','okt', 'nov', 'dec');
        
        /*Dagen*/
        $den = array('sunday', 'monday', 'tuesday', 'wednesday', 'thursday', 'friday', 'saturday');
        $dnl = array('Zondag', 'Maandag', 'Dinsdag', 'Woensdag', 'Donderdag', 'Vrijdag', 'Zaterdag');
        
        /*Afgekorte dagen*/
        $daen = array('sun', 'mon', 'tue', 'wed', 'thu', 'fri', 'sat');
        $danl = array('Zo', 'Ma', 'Di', 'Wo', 'Do', 'Vr', 'Za');
        
        $d = date($format, $time);
        $d = str_ireplace($men, $mnl, $d);
        $d = str_ireplace($maen, $manl, $d);
        $d = str_ireplace($den, $dnl, $d);
        $d = str_ireplace($daen, $danl, $d);
        $d = str_ireplace(" 0", " ", $d);
        $this->x = $d;
	}
    
    public function PRINTDATE(){
        echo $this->x;
    }
    
    public function GETDATE(){
        return $this->x;
    }
    
}

class JOURNALIST{
    private $number = 0;
    private $articles;
    private $db;
    
    public function __construct($sql) {
        $this->db = Database::OPEN();
        $this->number = $this->db->C($sql);
        $this->articles = $this->db->Q($sql);
	}
    
    public function COUNT(){
        echo $this->number;
    }
    
    public function __destruct() {
        $this->db = null;
    }

    
    
    public function PASTE($template){
        while($row = mysqli_fetch_array($this->articles)){
            $topaste = $template;
            $content = $row["content"];
            $content = str_replace("XPHP", "PHP", $content);
            $content = str_replace("images/", "cms/images/", $content);
            $content = str_replace("cms/cms/", "cms/", $content);
            $topaste = str_replace("<ct:title/>", $row["title"], $topaste);
            $topaste = str_replace("<ct:content/>", $content, $topaste);
            
            //$GLOBALS['dateformat']
            $d = $row["articledate"];
            $d = new DDT($d, $GLOBALS['dateformat']);
            $datum = $d->GETDATE();
            
            $topaste = str_replace("<ct:articledate/>", $datum, $topaste);
            $topaste = str_replace("<ct:id/>", $row["id"], $topaste);
            $topaste = str_replace("<ct:cover/>", "cms/" . $row["cover"], $topaste);
            //$topaste = str_replace("ct:cover", $row["cover"], $topaste);
            echo $topaste;
        }
    }
    
    public function LISTNAMES($template){
        while($row = mysqli_fetch_array($this->articles)){
            $topaste = $template;
            $topaste = str_replace("<ct:id/>", $row["id"], $topaste);
            $topaste = str_replace("<ct:cover/>", "cms/" . $row["cover"], $topaste);
            //$topaste = str_replace("ct:cover", "cms/" . $row["cover"], $topaste);
            $topaste = str_replace("<ct:name/>", $row["name"], $topaste);
            $topaste = str_replace("<ct:email/>", $row["email"], $topaste);
            echo $topaste;
        }
    }
    
    public function LISTFILES($template){
        while($row = mysqli_fetch_array($this->articles)){
            $topaste = $template;
            $topaste = str_replace("<ct:id/>", $row["id"], $topaste);
            $topaste = str_replace("<ct:cover/>", "cms/" . $row["path"], $topaste);
            $topaste = str_replace("ct:cover", "cms/" . $row["path"], $topaste);
            $topaste = str_replace("<ct:image/>", "cms/" . $row["path"], $topaste);
            
            $topaste = str_replace("<ct:path/>", "cms/" . $row["path"], $topaste);
            $topaste = str_replace("ct:image", "cms/" . $row["path"], $topaste);
            $topaste = str_replace("<ct:img/>", "cms/" . $row["path"], $topaste);
            $topaste = str_replace("ct:img", "cms/" . $row["path"], $topaste);
            echo $topaste;
        }
    }
        
    
}
class SEARCH{
    
    public function __construct($q, $template) {
        if(isset($_GET[$q])){
            $filter = $_GET[$q];
            $j = new JOURNALIST("select * from articles where title like '%$filter%' or content like '%$filter%'");   
            $j->PASTE($template);
        }else{
            echo "Geen zoekopdracht verzonden";
        }
	}
}

class OPENGROUP{
    private $articles;
    private $db;
    private $number;
    private $template;
    private $grouptype = 1;
    private $groupid;
    private $order = "ASC";
    private $limit = "";
    
    public function __construct($id, $limit = null) {
       $this->db = Database::OPEN();
       $this->groupid = $id;    
        
       if(!empty($limit)){
            $this->limit = $limit;
       }
        
       /*bepaal groepstype: 1 artikels, 2 albums, 3 namen*/
       $sql = "select * from grouparticles where groupid=$id $this->limit";
       $this->number = $this->db->C($sql);
       $this->articles = $this->db->Q($sql); 
       $this->grouptype();
	}
    
    private function grouptype(){
        echo $this->limit;
        $gid = $this->db->Q("select * from groups where id=$this->groupid");
        while($row = $gid->fetch_assoc()) {
            $this->grouptype = $row["type"];
        }
    }
    
    public function TOTAL(){
        return $this->number;
    }
    
    /*Paste werkt enkel als type=1 is*/
    public function PASTE($template, $order = null){
        if(!empty($order)){
            $this->order = $order;
        }
        
        
        $this->template = $template;
        $grouparts = array();
        $ids = "";
        $komma = "";
        if($this->number > 0){
            while($row = $this->articles->fetch_assoc()) {
                array_push($grouparts,$row["articleid"]);
                $ids = $ids . $komma .  $row["articleid"];
                $komma = ",";
            }
        }
        if($this->grouptype == "1"){
            $o = $this->order;


            /*ordenen in selectievolgotde*/
            $sql = "select * from articles where id in ($ids) order BY FIELD(id, $ids) $o";
            $j = new JOURNALIST($sql);   
            $j->PASTE($this->template);
        }
        if($this->grouptype == "2"){
            $o = $this->order;
            $sql = "select * from files where id in ($ids) order BY FIELD(id, $ids) $o";
            $j = new JOURNALIST($sql);   
            $j->LISTFILES($this->template);
        }
        if($this->grouptype == "3"){
            //authors
            $o = $this->order;
            $sql = "select * from authors where id in ($ids)";
            $j = new JOURNALIST($sql);   
            $j->LISTNAMES($this->template);
        }
        //open alles van articles where in list
    }
    
}

class OPENARTICLE{
    public function __construct($q, $template) {
        if(isset($_GET[$q])){
            $filter = $_GET[$q];
            $j = new JOURNALIST("select * from articles where id=$filter");   
            $j->PASTE($template);
        }else{
            //echo "Geen zoekopdracht verzonden";
        }
	}
}

?>
